/*
  Hardware UART
*/


#include <avr/io.h>


#define BAUD 115200
#define USEU2X 1


void uart_init(void) {
  PORTD |= _BV(PD0);
  DDRD |= _BV(PD1);
#if USEU2X
  UBRRL = (uint8_t)((double)F_CPU / (8.0 * BAUD) - 1.0 + 0.5);
  UCSRA |= _BV(U2X);
#else
  UBRRL = (uint8_t)((double)F_CPU / (16.0 * BAUD) - 1.0 + 0.5);
#endif
  UCSRB |= (_BV(TXEN) | _BV(RXEN));

  return;
}


void uart_putchar(unsigned char data) {
  while (bit_is_clear(UCSRA, UDRE)) ;
  UDR = data;

  return;
}
